var segments = [];

var pcSegments = ["Kindergarten", "First", "Second", "Third", "Fourth", "Fifth", "Sixth", "Seventh", "Eighth", "Principal", "Admin_Asst", "Cyo_Sports", "PTO", "Music", "Art", "PE"];

$(document).ready(function () {
  if (Parse.User.current()){
    redirectNonRegularUser(Parse.User.current());
  } else{
    redirectLoggedOutUser();
  }
  $("#username-text").text("(" + Parse.User.current().attributes.username + ")"); 
  $("#tags").tagsinput({
    confirmKeys: [13, 44, 32, 188]
  }); 
  for (var i = 0; i < segments.length; i++){
    $("#tags").tagsinput('add', segments[i]);
  }

  for (var i = 0; i < pcSegments.length; i++){
    $('#checkbox').append('<input type="checkbox" name="segments" class="chk" value="' + pcSegments[i] + '" />' + "  " + pcSegments[i] + " <br>"); 
  }

  $(".chk").change(function() {
    var ops;
    if(this.checked) {
       ops = "add";
    } else { 
      ops = "remove";
    }

     $("#tags").tagsinput(ops, $(this).val());
     $("#tags").tagsinput(ops, "PC-" + $(this).val());
});

  // Scheduled date and time
  $('#datetime12').combodate({
          value: new Date(),
          format:"YYYY-MM-DDTHH:mm:ss",
          template:"DD / MM / YYYY     hh : mm a",
          firstItem: "none",
          roundTime:false,
          minuteStep:1,
          smartDays:true,
          minYear: moment().format("YYYY") ,
          maxYear: (parseInt(moment().format("YYYY")) + 1) 
    }); 

  $("#push-time").change(function(){
      $( "select option:selected").each(function(){
          if($(this).attr("value")=="now"){
              $("#scheduled-details").hide(); 
          }
          if($(this).attr("value")=="scheduled"){ 
              $("#scheduled-details").show();
          } 
      });
  }).change();

  // Time Zone
  var currentTimeZone = moment().format('Z');
  $("#time-zone").append('<option value="'+currentTimeZone+'">'+currentTimeZone+'</option>');
  $("#time-zone").append('<option value="">Local to User');

  // Character count   
  Countable.live(document.getElementById("push-content"), function (counter) { 
    $("#count").text(counter.all);
  })
});

function redirectNonRegularUser(user){
  if (user.attributes.role == "admin") {
    window.location = 'admin.html';
  } 
}

function generateUUID(){
    var d = new Date().getTime();
    var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
        var r = (d + Math.random()*16)%16 | 0;
        d = Math.floor(d/16);
        return (c=='x' ? r : (r&0x3|0x8)).toString(16);
    });
    return uuid;
};

var campaignId;

function pushToClients(){

  campaignId = generateUUID();
  var iosStatusSelector = "#status-ios";
  var androidStatusSelector = "#status-android";

  // clear status
  $(iosStatusSelector).text( "");
  $(iosStatusSelector).removeAttr("class"); 
  $(androidStatusSelector).text( "");
  $(androidStatusSelector).removeAttr("class"); 

  var isIos = $('#ios-client').is(':checked');
  var isAndroid = $('#android-client').is(':checked');

  if(!isIos && !isAndroid){
    $(iosStatusSelector).attr("class","error"); 
    $(iosStatusSelector).text( "You need to select at least one Device Type");
  }

  if(isIos) { 
    $(iosStatusSelector).removeAttr("class"); 
    $(iosStatusSelector).text( "In progress...");
    push('ios', iosStatusSelector);
  }

  if(isAndroid) { 
    $(androidStatusSelector).removeAttr("class"); 
    $(androidStatusSelector).text( "In progress...");
    push('android', androidStatusSelector);
  }
}

function push(platform, statusSelector) {

  var content = $("#push-content").val();
  var screenNickname = $("#nickname").val();
  var tags = $("#tags").tagsinput('items');
  var options = {
      data: {}
  }

  // Add OS 
  options.where = {}
  options.where.deviceType = platform;
  
  // Add Tags 
  if(tags && tags.length > 0){ 
    options.where.channels = {"$in":tags};
  } 

  // Add Screen Nickname for deepLink
  if(screenNickname){
    options.data.nickname = screenNickname;
  } 

  // Add custom receiver for Android 
  if(platform == "android"){
    options.data.action = "com.talgrace.CUSTOM_NOTIF";
    options.data.content = content;
  } else {
    options.data.alert = content
    options.data.sound = "default"
  }

  // Scheduling Future Push Notifications
 if($( "#push-time option:selected" ).val()=="scheduled"){  
    options.push_time = ($("#datetime12").combodate("getValue") + $( "#time-zone option:selected" ).val());
  } 

  $.ajax({
     url: 'https://api.parse.com/1/push',
     type: 'post',
     data: JSON.stringify(options),
     headers: {
        "X-Parse-Application-Id": Parse.User.current().attributes.appId,
        "X-Parse-REST-API-Key": Parse.User.current().attributes.restKey,
    },
    contentType: 'application/json',
    dataType: 'json',
    error: function(xhr, error){
      $(statusSelector).attr("class","error");  
      $(statusSelector).text(  platform.toUpperCase() + " - " + "Error while sending notification:  " + JSON.parse(xhr.responseText).error);
    },
    success: function (data) { 
      $(statusSelector).attr("class","success");  
      $(statusSelector).text( platform.toUpperCase() + " - " + "Push sent successfuly");
      saveToArchive(options);
    }
});


function saveToArchive(options){

  var NotificationHistory = Parse.Object.extend("NotificationHistory"); // subclass of parse object
  var history = new NotificationHistory(); // new object instance  
   
  history.set("campignId", campaignId);
  history.set("fullData", JSON.stringify(options));

  var message;
  if(options.where.deviceType == "android"){
    message = options.data.content;
  } else if(options.where.deviceType == "ios") { 
    message = options.data.alert;
  }
  history.set("message", message);

  if("channels" in options.where){
    history.set("segments", JSON.stringify(options.where.channels["$in"]));
  }
  history.set("deviceType", options.where.deviceType);

  var deliveryTime = new Date(); 
  if("push_time" in options){
    deliveryTime = new Date(options.push_time);
  }
  history.set("deliveryTime", deliveryTime);
   
  history.save(null, {
    success: function(history) { 
    },
    error: function(history, error) {
      console.log("Error saving notification history. " + error)
    }
  });

}


}